#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>
#include <QtGui>
#include <QPointF>
#include <QPalette>
#include<math.h>

int YAXIS_Y1 = 150;
int YAXIS_Y2 = 700;
int YAXIS_X1 = 50;
int YAXIS_X2 = 50;
//XAXIS
int XAXIS_Y1 = 425;
int XAXIS_Y2 = 425;
int XAXIS_X1 = 50;
int XAXIS_X2 = 750;

int XAXISX1=0;
int XAXISY1=0;
int WIDTH=0;
int HEIGHT=0;
int STARTANGLE=0;
int SPANANGLE=0;
int flag=0;

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    Initialize();
    thread=new QThread;
        multithread=new MultiThread;
        //mainwindow=new MainWindow;

        multithread->moveToThread(thread);

        connect(multithread, SIGNAL(valueChanged(QString)), ui->label, SLOT(setText(QString)));
        connect(multithread, SIGNAL(multithreadRequested()), thread, SLOT(start()));
       // connect(multithread, SIGNAL(multithreadRequested()), thread, SLOT(changeTwentyfive()));
        connect(thread, SIGNAL(started()), multithread, SLOT(doMultiThraed()));
        connect(multithread,SIGNAL(setChange()),SLOT(setValue()));

        connect(multithread, SIGNAL(finished()), thread, SLOT(quit()), Qt::DirectConnection);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void MainWindow ::Initialize()
{
         x=50.0;
         y=425.0;
         amplitude=0.0;
         Time=0.0;
         timePeriod=0;
          x1=x;
          y1=y;
          jcounter=0;
          flagncount=0;
          ui->textEdit_amplitude->setText("60");
}

void MainWindow::paintEvent(QPaintEvent *pEvent)
{

    QWidget::paintEvent(pEvent);
        QPainter painter(this);

        painter.setRenderHint(QPainter::Antialiasing);
        painter.setPen(Qt::red);

        painter.drawText(35,185,"A");
        painter.drawText(35,200,"/");
        painter.drawText(36,203,"|");
        painter.drawText(37,203,"|");
        painter.drawText(38,200,"\\ ");
        painter.drawText(35,220,"Y");
        painter.drawText(35,427,"O");

        painter.drawText(650,448,"-> TIME - X axis");


        painter.drawLine(YAXIS_X1,YAXIS_Y1,YAXIS_X2,YAXIS_Y2);
        painter.drawLine(XAXIS_X1,XAXIS_Y1,XAXIS_X2,XAXIS_Y2);


        //HERE WE PASTE OUR CODE
        QPainterPath path;
            path.moveTo(x,y);

            qreal t=0;

            for (int j=0;j<jcounter;j++)
            {
             t=amplitude;
                for(int a=1;a<amplitude;a++)
                 {
                  x1+=timePeriod/t;
                  t--;
                  y1-=1;
                  path.lineTo(x1,y1);
                  path.moveTo(x1,y1);
                 }


                t=1;
                 for(int b=amplitude;b>0;b--)
                 {

                    x1+=timePeriod/t;
                    t++;
                    y1+=1;
                    path.lineTo(x1,y1);
                    path.moveTo(x1,y1);
                 }
             //negative direction
                 t=amplitude;
                 for(int a=1;a<amplitude;a++)
                  {
                   x1+=timePeriod/t;
                   t--;
                   y1+=1;
                   path.lineTo(x1,y1);
                   path.moveTo(x1,y1);
                  }

                 t=1;

                  for(int b=amplitude;b>0;b--)
                  {
                       x1+=timePeriod/t;
                       t++;
                       y1-=1;
                       path.lineTo(x1,y1);
                       path.moveTo(x1,y1);
                  }


        //HERE WE APPLY OUR EQUATION FOR DAMPED HARMONIC SINEWAVE
        //nextamplitude=amplitude*e raised-(bt/2m)
        //m mass of body
        //t-time
        //b-damping constant
                    amplitude-=8;

        //          qreal amp=amplitude*qExp(1/(1*timePeriod)/2*10);
        //          amplitude=abs(amp);
                    flagncount++;


            }

        painter.drawPath(path);

        x=50.0;
        y=425.0;
        amplitude=0.0;
        Time=0.0;
        timePeriod=0;
        x1=x;
        y1=y;
        jcounter=0;
        flagncount=0;

}

void MainWindow :: setValue()
{
    QString var_Amplitude=ui->textEdit_amplitude->toPlainText();
        amplitude=var_Amplitude.toInt();

        //msgBox.setText(var_Amplitude);
        // msgBox.show();

        QString var_Timeperiod=ui->comboBox_timeprd->currentText();
        Time=var_Timeperiod.toInt();
        if(Time==10)
        {
            timePeriod=10/2;
        }else if(Time==20)
        {
            timePeriod=20/2;
        }else if(Time==30)
        {
            timePeriod=30/2;
        }

        QString s=ui->label->text();
        //msgBox.setText(s);
        //msgBox.show();
        int lbl=s.toInt();
    if(lbl==1)
        {

        jcounter=1;
         repaint();
    }else if(lbl==2)
    {


        jcounter=2;
         repaint();


    }else if(lbl==3)
    {

        jcounter=3;
         repaint();

    }else if(lbl==4)
    {


        jcounter=4;
         repaint();

    }else if(lbl==5)
    {


        jcounter=5;
         repaint();

    }else if(lbl==6)
    {

        jcounter=6;
         repaint();

    }else if(lbl==7)
    {


        jcounter=7;
         repaint();

    }else if(lbl==8)
    {
        jcounter=8;
         repaint();

    }else if(lbl==9)
    {
        jcounter=9;
         repaint();

    }


}


void MainWindow::on_pushButton_clicked()
{
        multithread->abort();
       thread->wait();
       multithread->requestThread();
}

void MainWindow::on_pushButton_2_clicked()
{
    multithread->abort();
        thread->wait();
}

void MainWindow::on_actionSTART_activated()
{
    //CODE FOR START
    multithread->abort();
    thread->wait();
    multithread->requestThread();
}

void MainWindow::on_actionPAUSE_activated()
{
    //CODE FOR PAUSING THE THREAD
         multithread->abort();
         thread->wait();
}
